// Custom Theming for Angular Material
// For more information: https://material.angular.io/guide/theming

@use "@angular/material" as mat;
@use "ec-simpl-labs-palettes" as palette;
@use "sass:map";
// Plus imports for other components in your app.

// Include the common styles for Angular Material. We include this here so that you only
// have to load a single css file for Angular Material in your app.
// Be sure that you only ever include this mixin once!
@include mat.core();

$EC-primary-palette: palette.$EC-primary-palette;
$EC-accent-palette: palette.$EC-accent-palette;
$EC-error-palette: palette.$EC-error-palette;
$simpl-labs-background-palette: palette.$simpl-labs-background-palette;
$simpl-labs-foreground-palette: palette.$simpl-labs-foreground-palette;

$simpl-labs-primary: mat.define-palette($EC-primary-palette);
$simpl-labs-accent: mat.define-palette($EC-accent-palette);
// The warn palette is optional (defaults to red).
$simpl-labs-warn: mat.define-palette($EC-error-palette);

// EU base colors
// https://ec.europa.eu/component-library/eu/guidelines/colours/
//
$eu-primary: mat.get-color-from-palette($EC-primary-palette, 500);
$eu-primary-100: mat.get-color-from-palette($EC-primary-palette, 100);
$eu-primary-400: mat.get-color-from-palette($EC-primary-palette, 400);
$eu-primary-900: mat.get-color-from-palette($EC-primary-palette, 900);

$eu-accent: mat.get-color-from-palette($EC-accent-palette, 500);
$eu-error: mat.get-color-from-palette($EC-error-palette, 500);
$eu-info: $eu-primary;

$eu-success-light: mat.get-color-from-palette(palette.$EC-success-palette, 100);
$eu-success: mat.get-color-from-palette(palette.$EC-success-palette, 500);
$eu-success-dark: mat.get-color-from-palette(palette.$EC-success-palette, 900);

$eu-warning: mat.get-color-from-palette(palette.$EC-warning-palette, 500);

// Greys
$grey-50: mat.get-color-from-palette(palette.$grey-palette, 50);
$grey-300: mat.get-color-from-palette(palette.$grey-palette, 300);
$grey-500: mat.get-color-from-palette(palette.$grey-palette, 500);
$grey-600: mat.get-color-from-palette(palette.$grey-palette, 600);
$grey-800: mat.get-color-from-palette(palette.$grey-palette, 800);
$grey-900: mat.get-color-from-palette(palette.$grey-palette, 900);

// Text colors
$eu-dark-primary-text: palette.$dark-primary-text;
$eu-dark-secondary-text: palette.$dark-secondary-text;

$slabs-white: #ffffff;

$ec-background: palette.$ec-background;
$background: mat.get-color-from-palette(
  $simpl-labs-background-palette,
  background
);

// Include theme styles for core and each component used in your app.
// Alternatively, you can import and @include the theme mixins for each component
// that you are using.

// Typography config based on the default, but using "Arial, sans-serif" as the
// default font family for all levels.
$simpl-labs-typography: mat.define-typography-config(
  $font-family: "Arial, sans-serif",
  $headline-1:
    mat.define-typography-level(42px, 52px, 400, $letter-spacing: -0.05em),
  $headline-2: mat.define-typography-level(36px, 44px, 400),
  $headline-3: mat.define-typography-level(32px, 40px, 400),
  $headline-4: mat.define-typography-level(28px, 32px, 400),
  // ...
  $headline-5: mat.define-typography-level(24px, 28px, 400),
  $headline-6: mat.define-typography-level(20px, 28px, 400),
  $subtitle-1: mat.define-typography-level(16px, 24px, 400),
  $subtitle-2: mat.define-typography-level(14px, 20px, 400),
  $body-1: mat.define-typography-level(16px, 24px, 400),
  $body-2: mat.define-typography-level(14px, 20px, 400),
  $caption: mat.define-typography-level(12px, 20px, 400),
  $button: mat.define-typography-level(14px, 20px, 400),
);

// Create the theme object. A theme consists of configurations for individual
// theming systems such as "color" or "typography".
$simpl-labs-theme: mat.define-light-theme(
  (
    color: (
      primary: $simpl-labs-primary,
      accent: $simpl-labs-accent,
      warn: $simpl-labs-warn,
    ),
    typography: $simpl-labs-typography,
    density: 0,
  )
);

// Finally let's add (merge) the fore- and back- ground colors:

$color-map: map.get($simpl-labs-theme, "color");

$modified-color-map: map.merge(
  $color-map,
  (
    "background": $simpl-labs-background-palette,
    "foreground": $simpl-labs-foreground-palette,
  )
);

$simpl-labs-theme: map.merge(
  $simpl-labs-theme,
  (
    "color": $modified-color-map,
  )
);

// Style values to be passed to styles.scss
$font: mat.get-theme-typography($simpl-labs-theme, body-1);

@include mat.all-component-themes($simpl-labs-theme);
